package uhk.salay.npl.demonpl.jpa.model;

import java.util.Objects;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import lombok.Data;

@Data
@Entity
@Table(name = "Relations")
public class Relation {
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private int id;
  @Column(name = "Type")
  private String type;

  @OneToOne
  @JoinColumn(name = "Entiti_From", referencedColumnName = "id")
  private uhk.salay.npl.demonpl.jpa.model.Entity entityFrom;

  @OneToOne
  @JoinColumn(name = "Entiti_To", referencedColumnName = "id")
  private uhk.salay.npl.demonpl.jpa.model.Entity entityTo;

  @OneToOne
  @JoinColumn(name = "File_id", referencedColumnName = "id")
  private File file;

  public Relation() {
  }

  public Relation(String type, uhk.salay.npl.demonpl.jpa.model.Entity entityFrom, uhk.salay.npl.demonpl.jpa.model.Entity entityTo,
                    File file
                  ) {
    this.type = type;
    this.entityFrom = entityFrom;
    this.entityTo = entityTo;
    this.file = file;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Relation relation = (Relation) o;
    return Objects.equals(type, relation.type) &&
        Objects.equals(entityFrom, relation.entityFrom) &&
        Objects.equals(entityTo, relation.entityTo);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, entityFrom, entityTo);
  }
}
