package uhk.salay.npl.demonpl;

import java.util.List;
import org.junit.Assert;
import org.junit.Test;
import uhk.salay.npl.demonpl.jpa.model.Entity;
import uhk.salay.npl.demonpl.jpa.model.Relation;
import uhk.salay.npl.demonpl.jpa.model.Type;

public class DatabseTest extends DemonplApplicationTests {
  @Test
  public void typeTest() {
    final List<Type> all = typeRepository.findAll();
    for (Type type : all) {
      System.out.println(type.getName());
    }

    final Type type = new Type();
    type.setName("test");
    final Type type1 = typeRepository.saveAndFlush(type);
    System.out.println(type1);

    final List<Type> all1 = typeRepository.findAll();
    for (Type type2 : all1) {
      System.out.println(type2.getName());
    }
    Assert.assertEquals(all.size() + 1, all1.size());
  }

  @Test
  public void entityTest() {
    final List<Entity> all = entityRepository.findAll();
    System.out.println(all.get(0).getName() + " entity name");
    System.out.println(all.get(0).getType().getName() + " type name");
  }

  @Test
  public void saveEntity() {
    final Type type = typeRepository.findByName("Person");

    final Entity entity = new Entity();
    entity.setName("JmenoEntity");
    entity.setType(type);

    entityRepository.saveAndFlush(entity);
  }

  @Test
  public void relationTest() {
    final List<Relation> all = relationsRepository.findAll();
    final Relation relation = all.get(0);
    System.out.println(relation.getType() + " relation type");
    System.out.println(relation.getEntityFrom().getName() + " entityFrom name");
    System.out.println(relation.getEntityFrom().getType().getName() + " entityFrom type name");
    System.out.println(relation.getEntityTo().getName() + " entityTo name");
    System.out.println(relation.getEntityTo().getType().getName() + " entityTo type name");
  }


  @Test
  public void saveRelation() {
    final Type typeFrom = typeRepository.findByName("Person");
    final Type typeTo = typeRepository.findByName("Oceneni");

    final Entity radek = entityRepository.findByNameAndType("Radek", typeFrom).get(0);
    final Entity oscar = entityRepository.findByNameAndType("Oscar", typeTo).get(0);

    final Relation relation = new Relation();
    relation.setType("TestRelatinType");
    relation.setEntityFrom(radek);
    relation.setEntityTo(oscar);
    relationsRepository.save(relation);
  }

  @Test
  public void findRelation() {
    final Type type = typeRepository.findByName("Person");
    final Entity entity = entityRepository.findByNameAndType("Radek", type).get(0);
    final List<Relation> relationByEntityFrom = relationsRepository.findRelationByEntityFrom(entity);
    final Relation relation = relationByEntityFrom.get(0);
    System.out.println(relation.getType() + " relation type");
    System.out.println(relation.getEntityFrom().getName() + " entityFrom name");
    System.out.println(relation.getEntityFrom().getType().getName() + " entityFrom type name");
    System.out.println(relation.getEntityTo().getName() + " entityTo name");
    System.out.println(relation.getEntityTo().getType().getName() + " entityTo type name");

  }
}
